/* Program creates data on parents */

libname lib24 "W:\Uudet_datat\U0599_9_toim\";
libname lib100 "W:\Tutkimusprojektit\Kirjanpito\Dokumentaatio\JAR\Datat\";

run;

* Reads intial sample on executives;

data tutkimushenkilot;

set lib100.tutkimushenkilot_id_year_250925;

mukana = 1;

keep id year mukana;

run;

proc sort nodupkey data = tutkimushenkilot;
by id year;
run;

* Read data on parents;

data perheet;
set lib100.kaikki_perheet_data_250925;
run;

* Combines datasets on executives and their parents;

data kaikki_2;
merge tutkimushenkilot perheet;
by id;

if mukana = 1;

if m_id = '' and f_id = '' then delete;

run;

* Separate datasets for fathers and mothers;

data aidit;
set kaikki_2;

keep m_id year mukana;

rename m_id = id;

run;

proc sort data = aidit;
by id year;
run;


data isat;
set kaikki_2;

keep f_id year mukana;

rename f_id = id;

run;

proc sort data = isat;
by id year;
run;

* Demografic data;

data demografiset;
 set lib100.demografiset_220524;

 if year >= 1987;
 
 if MARITAL_STATUS = 2 then D_MARITAL_STATUS = 0;
 if MARITAL_STATUS = 1 or 
 MARITAL_STATUS = 4 or
 MARITAL_STATUS = 5 then D_MARITAL_STATUS = 1;

 if ID ^= lag (ID) then do; 
	CUM_Sum_divorce = 0; 
	CUM_Sum_Married = 0;

	end;

 CUM_Sum_divorce + Divorce;
 CUM_Sum_Married + Married;

KUNTA = MUNICIPALITY*1;

keep id year D_MARITAL_STATUS AGE BIRTHYEAR MALE MARITAL_STATUS NUM_CHILDREN_UNDER_18 Divorce Married Divorce_prev_5_years
CUM_Sum_divorce CUM_Sum_married MAAKUNTA KUNTA SOCIOECONOMIC_POSITION RESIDENTIALFORM;

run;

proc means noprint sum data = demografiset;
var Divorce Married;

by id;

output out = Marital_sums sum = Lifetime_Sum_Divorce Lifetime_Sum_Married;

run;

data demografiset_kieli;
 set lib100.demografiset_220524;

keep id year NATIVE_LANGUAGE;
run;

proc sort data = demografiset_kieli;
by id YEAR;
run;

proc sort nodupkey data = demografiset_kieli;
by id;
run;

data demografiset_kieli_2;
set demografiset_kieli;

keep id NATIVE_LANGUAGE;
run;

data skunta;
set lib24.u0599_9_kaikki_skunta_s;

rename shnro = id;

run;

proc sort data = skunta;
by id;
run;

data demografiset_2;
merge demografiset Marital_sums skunta;

by id;

CUM_Sum_divorce2 = lag(CUM_Sum_divorce);
CUM_Sum_Married2 = lag(CUM_Sum_Married);

if ID ^= lag (ID) then CUM_Sum_divorce2 = .;
if ID ^= lag (ID) then CUM_Sum_Married2 = .;

if year > 1993;

drop CUM_Sum_divorce CUM_Sum_married _type_ _freq_ married num_children_under_18 lifetime_sum_married cum_sum_married;
rename CUM_Sum_divorce2 = CUM_Sum_divorce CUM_Sum_Married2 = CUM_Sum_Married;
run;

* Education data;

data Koulutus;
 set lib100.education_170524;

 if year > 1993;
 
 
keep id year edulevel business_socialdeg;

run;

* Income data;

data Tulodata;
set lib100.henkiloverotus_220925;

if year > 1993;

* Inflation adjustment;

if year = 1994 then TOTALINCOME2 = TOTALINCOME * 1.43;
if year = 1995 then TOTALINCOME2 = TOTALINCOME * 1.42;
if year = 1996 then TOTALINCOME2 = TOTALINCOME * 1.41;
if year = 1997 then TOTALINCOME2 = TOTALINCOME * 1.39;
if year = 1998 then TOTALINCOME2 = TOTALINCOME * 1.37;
if year = 1999 then TOTALINCOME2 = TOTALINCOME * 1.36;
if year = 2000 then TOTALINCOME2 = TOTALINCOME * 1.31;
if year = 2001 then TOTALINCOME2 = TOTALINCOME * 1.28;
if year = 2002 then TOTALINCOME2 = TOTALINCOME * 1.26;
if year = 2003 then TOTALINCOME2 = TOTALINCOME * 1.25;
if year = 2004 then TOTALINCOME2 = TOTALINCOME * 1.25;
if year = 2005 then TOTALINCOME2 = TOTALINCOME * 1.23;
if year = 2006 then TOTALINCOME2 = TOTALINCOME * 1.21;
if year = 2007 then TOTALINCOME2 = TOTALINCOME * 1.18;
if year = 2008 then TOTALINCOME2 = TOTALINCOME * 1.14;
if year = 2009 then TOTALINCOME2 = TOTALINCOME * 1.14;
if year = 2010 then TOTALINCOME2 = TOTALINCOME * 1.12;
if year = 2011 then TOTALINCOME2 = TOTALINCOME * 1.09;
if year = 2012 then TOTALINCOME2 = TOTALINCOME * 1.06;
if year = 2013 then TOTALINCOME2 = TOTALINCOME * 1.04;
if year = 2014 then TOTALINCOME2 = TOTALINCOME * 1.03;
if year = 2015 then TOTALINCOME2 = TOTALINCOME * 1.03;
if year = 2016 then TOTALINCOME2 = TOTALINCOME * 1.03;
if year = 2017 then TOTALINCOME2 = TOTALINCOME * 1.02;
if year = 2018 then TOTALINCOME2 = TOTALINCOME * 1.01;
if year = 2019 then TOTALINCOME2 = TOTALINCOME * 1;

LN_TOTALINCOME = log(TOTALINCOME2 + 1);

keep id year salarytotal LN_salarytotal totalincome2 LN_totalincome capitaltotal LN_capitaltotal;
rename totalincome2 = totalincome;

run;

* Crime data;

data kirjanpitorikos_yt;

set lib100.Kaik_vanh_tuomiot_tvuosi_250925; /* Based on the year of committing the crime */

if year > 1993;

mukaan = 1;

run;

* Mental disorder diagnoses data;

data hilmot;
set lib100.personyear_avo_180324;

if year > 1993;

D_CUM_SUBSTANCE = 0;
D_CUM_ALL_BUT_SUBS = 0;

if CUM_NSUBSTANCE > 0 then D_CUM_SUBSTANCE = 1;
if CUM_NALL_BUT_SUBS > 0 then D_CUM_ALL_BUT_SUBS = 1;

keep id year D_CUM_SUBSTANCE D_CUM_ALL_BUT_SUBS CUM_NALL_BUT_SUBS CUM_NSUBSTANCE;

run;

* Parents' positions in firms;

data vanh_positions;
set lib100.positions;

keep id year;

run;

data vanh_positions_a;
set lib100.positions_asiakastieto_070824;

if 2016 <= year <= 2019;
if asema = 'Varsinainen jasen' or asema = 'Puheenjohtaja' or asema = 'Toimitusjohtaja';

keep id year;

run;

data vanh_positions_2;
set vanh_positions vanh_positions_a;
run;

proc sort nodupkey data = vanh_positions_2;
by id year;
run;

data vanh_positions_3;
set vanh_positions_2;

Vanh_positio = 1;

if ID ^= lag (ID) then do;
 
	CUM_Vanh_positio = 0; 
	
	end;

 CUM_Vanh_positio + Vanh_positio;
	

keep id year CUM_Vanh_positio;

run;

* Ownership data;

data omistusosuus;
set lib100.osakkeenomistajat_data_230925;

keep firm id percentageown;

run;

proc sort nodupkey data = omistusosuus;
by id firm;
run;

proc transpose data = omistusosuus out = vanh_omistusosuus prefix = firm;
by id;
var firm;

run;

* Combines all data;

proc sort data = demografiset_2;
by id year;
run;

proc sort data = koulutus;
by id year;
run;

proc sort data = tulodata;
by id year;
run;

proc sort data = kirjanpitorikos_yt;
by id year;
run;

proc sort data = hilmot;
by id year;
run;

proc sort data = vanh_positions_3;
by id year;
run;

proc sort data = vanh_omistusosuus;
by id;
run;

* Mothers;

data Aidit_2;
merge Aidit demografiset_2 koulutus tulodata kirjanpitorikos_yt hilmot vanh_positions_3;
by id year;

if male = . then delete;
if birthyear = . then delete;
if id = '' then delete;
if mukana = . then delete;
if mukaan = . then delete;

if BUSINESS_SOCIALDEG = . then BUSINESS_SOCIALDEG = 0;
if EDULEVEL = . then EDULEVEL = 0;

LN_AGE = log(AGE+1);

if D_Lifetime_Kirjpitorikos_tuomio = . then D_Lifetime_Kirjpitorikos_tuomio = 0;
if D_Lifetime_Kirjpitorikos = . then D_Lifetime_Kirjpitorikos = 0;
if D_Lifetime_Muu_rikos_3_tuomio = . then D_Lifetime_Muu_rikos_3_tuomio = 0;
if D_Lifetime_Muu_rikos_4_tuomio = . then D_Lifetime_Muu_rikos_4_tuomio = 0;
if D_Lifetime_Muu_rikos_5_tuomio = . then D_Lifetime_Muu_rikos_5_tuomio = 0;
if D_Lifetime_Talous_tuomio = . then D_Lifetime_Talous_tuomio = 0;
if D_Lifetime_Talous_kaikki = . then D_Lifetime_Talous_kaikki = 0;
if D_Lifetime_Talous_kaikki_tuomio = . then D_Lifetime_Talous_kaikki_tuomio = 0;
if D_Lifetime_Henkiterv = . then D_Lifetime_Henkiterv = 0;
if D_Lifetime_Henkiterv_tuomio = . then D_Lifetime_Henkiterv_tuomio = 0;
if D_Lifetime_Liikenne = . then D_Lifetime_Liikenne = 0;
if D_Lifetime_Liikenne_tuomio = . then D_Lifetime_Liikenne_tuomio = 0;
if D_Lifetime_DUI_tuomio = . then D_Lifetime_DUI_tuomio = 0;
if D_Lifetime_Finan_fraud = . then D_Lifetime_Finan_fraud = 0;
if D_Lifetime_Tax_fraud = . then D_Lifetime_Tax_fraud = 0;
if D_Lifetime_other_fraud = . then D_Lifetime_other_fraud = 0;

if D_Lifetime_Talous_kaikki_v = . then D_Lifetime_Talous_kaikki_v = 0;
if D_Lifetime_Talous_kaikki_s = . then D_Lifetime_Talous_kaikki_s = 0;
if D_Lifetime_Talous_kaikki_ehdol_v = . then D_Lifetime_Talous_kaikki_ehdol_v = 0;
if D_Lifetime_Talous_kaikki_ehdot_v = . then D_Lifetime_Talous_kaikki_ehdot_v = 0;
if D_Lifetime_muu_rikos_4_v = . then D_Lifetime_muu_rikos_4_v = 0;
if D_Lifetime_muu_rikos_4_s = . then D_Lifetime_muu_rikos_4_s = 0;

if Lifetime_CUM_Muu3 = . then Lifetime_CUM_Muu3 = 0;
if Lifetime_CUM_Muu4 = . then Lifetime_CUM_Muu4 = 0;
if Lifetime_CUM_Muu5 = . then Lifetime_CUM_Muu5 = 0;
if Lifetime_CUM_Talous = . then Lifetime_CUM_Talous = 0;
if Lifetime_CUM_Talous_kaikki = . then Lifetime_CUM_Talous_kaikki = 0;
if Lifetime_CUM_Henkiterv = . then Lifetime_CUM_Henkiterv = 0;
if Lifetime_CUM_Liikenne = . then Lifetime_CUM_Liikenne = 0;
if Lifetime_CUM_KPrikos_kaikki = . then Lifetime_CUM_KPrikos_kaikki = 0;
if Lifetime_CUM_Finan_rep_fraud = . then Lifetime_CUM_Finan_rep_fraud = 0;
if Lifetime_CUM_Tax_relat_fraud = . then Lifetime_CUM_Tax_relat_fraud = 0;
if Lifetime_CUM_Other_finan_crime = . then Lifetime_CUM_Other_finan_crime = 0;

if Lifetime_CUM_Talous_kaikki_v = . then Lifetime_CUM_Talous_kaikki_v = 0;
if Lifetime_CUM_Talous_kaikki_s = . then Lifetime_CUM_Talous_kaikki_s = 0;
if Ltime_CUM_Talous_kaikki_ehdol_v = . then Ltime_CUM_Talous_kaikki_ehdol_v = 0;
if Ltime_CUM_Talous_kaikki_ehdot_v = . then Ltime_CUM_Talous_kaikki_ehdot_v = 0;
if Lifetime_CUM_muu_rikos_4_v = . then Lifetime_CUM_muu_rikos_4_v = 0;
if Lifetime_CUM_muu_rikos_4_s = . then Lifetime_CUM_muu_rikos_4_s = 0;

if D_Kirjanpitorikos_tuomio = . then D_Kirjanpitorikos_tuomio = 0;
if D_Kirjanpitorikos_tuomio_2 = . then D_Kirjanpitorikos_tuomio_2 = 0;
if D_Kirjanpitorikos_kaikki_2 = . then D_Kirjanpitorikos_kaikki_2 = 0;
if D_Muu_rikos_3_tuomio = . then D_Muu_rikos_3_tuomio = 0;
if D_Muu_rikos_4_tuomio = . then D_Muu_rikos_4_tuomio = 0;
if D_Muu_rikos_5_tuomio = . then D_Muu_rikos_5_tuomio = 0;
if D_Muu_rikos_3_tuomio_2 = . then D_Muu_rikos_3_tuomio_2 = 0;
if D_Muu_rikos_4_tuomio_2 = . then D_Muu_rikos_4_tuomio_2 = 0;
if D_Muu_rikos_5_tuomio_2 = . then D_Muu_rikos_5_tuomio_2 = 0;
if D_Muu_rikos_3_2 = . then D_Muu_rikos_3_2 = 0;
if D_Muu_rikos_4_2 = . then D_Muu_rikos_4_2 = 0;
if D_Muu_rikos_5_2 = . then D_Muu_rikos_5_2 = 0;
if D_Talous_tuomio = . then D_Talous_tuomio = 0;
if D_Talous_kaikki_tuomio = . then D_Talous_kaikki_tuomio = 0;
if D_Talous_tuomio_2 = . then D_Talous_tuomio_2 = 0;
if D_Talous_kaikki_tuomio_2 = . then D_Talous_kaikki_tuomio_2 = 0;
if D_Talous_2 = . then D_Talous_2 = 0;
if D_Talous_kaikki_2 = . then D_Talous_kaikki_2 = 0;
if D_Henkiterv_tuomio = . then D_Henkiterv_tuomio = 0;
if D_Liikenne_tuomio = . then D_Liikenne_tuomio = 0;
if D_Liikenne_tuomio_2 = . then D_Liikenne_tuomio_2 = 0;

if D_Talous_kaikki_vankeus_2 = . then D_Talous_kaikki_vankeus_2 = 0;
if D_Talous_kaikki_sakko_2 = . then D_Talous_kaikki_sakko_2 = 0;
if D_Talous_kaikki_vankeus_tuomio_2 = . then D_Talous_kaikki_vankeus_tuomio_2 = 0;
if D_Talous_kaikki_ehdol_vankeus_2 = . then D_Talous_kaikki_ehdol_vankeus_2 = 0;
if D_Talous_kaikki_ehdot_vankeus_2 = . then D_Talous_kaikki_ehdot_vankeus_2 = 0;

if D_muu_rikos_4_vankeus_2 = . then D_muu_rikos_4_vankeus_2 = 0;
if D_muu_rikos_4_sakko_2 = . then D_muu_rikos_4_sakko_2 = 0;
if D_muu_rikos_4_vankeus_tuomio_2 = . then D_muu_rikos_4_vankeus_tuomio_2 = 0;
if D_muu_rikos_4_ehdol_vankeus_2 = . then D_muu_rikos_4_ehdol_vankeus_2 = 0;
if D_muu_rikos_4_ehdot_vankeus_2 = . then D_muu_rikos_4_ehdot_vankeus_2 = 0;

if CUM_Muu3_tuomio = . then CUM_muu3_tuomio = 0;
if CUM_Muu4_tuomio = . then CUM_muu4_tuomio = 0;
if CUM_Muu5_tuomio = . then CUM_muu5_tuomio = 0;
if CUM_Talous_tuomio = . then CUM_Talous_tuomio = 0;
if CUM_Talous_kaikki_tuomio = . then CUM_Talous_kaikki_tuomio = 0;
if CUM_Liikenne_tuomio = . then CUM_Liikenne_tuomio = 0;
if CUM_Kirjanpitorikos_tuomio = . then CUM_Kirjanpitorikos_tuomio = 0;

if CUM_Muu3 = . then CUM_muu3 = 0;
if CUM_Muu4 = . then CUM_muu4 = 0;
if CUM_Muu5 = . then CUM_muu5 = 0;
if CUM_Talous = . then CUM_Talous = 0;
if CUM_Talous_kaikki = . then CUM_Talous_kaikki = 0;
if CUM_Kirjanpitorikos_kaikki = . then CUM_Kirjanpitorikos_kaikki = 0;
if CUM_Liikenne = . then CUM_Liikenne = 0;
if CUM_Henkiterveys = . then CUM_Henkiterveys = 0;
if CUM_Finan_rep_fraud = . then CUM_Finan_rep_fraud = 0;
if CUM_Tax_relat_fraud = . then CUM_Tax_relat_fraud = 0;
if CUM_other_finan_crime = . then CUM_other_finan_crime = 0;

if CUM_Talous_kaikki_vankeus = . then CUM_Talous_kaikki_vankeus = 0;
if CUM_Talous_kaikki_sakko = . then CUM_Talous_kaikki_sakko = 0;
if CUM_Talous_kaikki_ehdol_vankeus = . then CUM_Talous_kaikki_ehdol_vankeus = 0;
if CUM_Talous_kaikki_ehdot_vankeus = . then CUM_Talous_kaikki_ehdot_vankeus = 0;

if CUM_muu_rikos_4_vankeus = . then CUM_muu_rikos_4_vankeus = 0;
if CUM_muu_rikos_4_sakko = . then CUM_muu_rikos_4_sakko = 0;
if CUM_muu_rikos_4_ehdol_vankeus = . then CUM_muu_rikos_4_ehdol_vankeus = 0;
if CUM_muu_rikos_4_ehdot_vankeus = . then CUM_muu_rikos_4_ehdot_vankeus = 0;

If CUM_Vanh_positio = . then CUM_Vanh_positio = 0;

D_Vanh_positio = 0;
if CUM_Vanh_positio > 0 then D_Vanh_positio = 1;

if D_CUM_SUBSTANCE = . then D_CUM_SUBSTANCE = 0;
if D_CUM_ALL_BUT_SUBS = . then D_CUM_ALL_BUT_SUBS = 0;
if CUM_NALL_BUT_SUBS = . then CUM_NALL_BUT_SUBS = 0;
if CUM_NSUBSTANCE = . then CUM_NSUBSTANCE = 0;

rename CUM_Muu3_tuomio = M_CUM_muu3_tuomio CUM_Muu4_tuomio = M_CUM_muu4_tuomio CUM_Muu5_tuomio = M_CUM_muu5_tuomio CUM_Talous_tuomio = M_CUM_Talous_tuomio CUM_Talous_kaikki_tuomio = M_CUM_Talous_kaikki_tuomio
CUM_Liikenne_tuomio = M_CUM_Liikenne_tuomio CUM_Liikenne = M_CUM_Liikenne CUM_Kirjanpitorikos_tuomio = M_CUM_Kirjanpitorikos_tuomio CUM_Henkiterveys = M_CUM_Henkiterveys

CUM_Muu3 = M_CUM_muu3 CUM_Muu4 = M_CUM_muu4 CUM_Muu5 = M_CUM_muu5 CUM_Talous = M_CUM_Talous CUM_Talous_kaikki = M_CUM_Talous_kaikki
CUM_Kirjanpitorikos_kaikki = M_CUM_Kirjanpitorikos_kaikki CUM_Finan_rep_fraud = M_CUM_Finan_rep_fraud CUM_Tax_relat_fraud = M_CUM_Tax_relat_fraud
CUM_other_finan_crime = M_CUM_other_finan_crime

D_Lifetime_Kirjpitorikos_tuomio = M_D_Lifetime_KPrikos_tuomio D_lifetime_Kirjpitorikos = M_D_lifetime_Kirjpitorikos 

D_Lifetime_Finan_fraud = M_D_Lifetime_Finan_fraud D_Lifetime_Tax_fraud = M_D_Lifetime_Tax_fraud D_Lifetime_other_fraud  = M_D_Lifetime_other_fraud

Lifetime_CUM_Muu3 = M_Lifetime_CUM_Muu3
Lifetime_CUM_Muu4 = M_Lifetime_CUM_Muu4
Lifetime_CUM_Muu5 = M_Lifetime_CUM_Muu5
Lifetime_CUM_Talous = M_Lifetime_CUM_Talous
Lifetime_CUM_Talous_kaikki = M_Lifetime_CUM_Talous_kaikki
Lifetime_CUM_Henkiterv = M_Lifetime_CUM_Henkiterv
Lifetime_CUM_Liikenne = M_Lifetime_CUM_Liikenne
Lifetime_CUM_KPrikos_kaikki = M_Lifetime_CUM_KPrikos_kaikki
Lifetime_CUM_Finan_rep_fraud = M_Lifetime_CUM_Finan_rep_fraud
Lifetime_CUM_Tax_relat_fraud = M_Lifetime_CUM_Tax_relat_fraud
Lifetime_CUM_Other_finan_crime = M_Lifetime_CUM_Other_finan_crime

D_Kirjanpitorikos_tuomio = M_D_Kirjanpitorikos_tuomio

D_lifetime_talous_tuomio = M_D_lifetime_talous_tuomio D_lifetime_talous_kaikki_tuomio = M_D_lifetime_talous_kaik_tuomio D_lifetime_talous_kaikki = M_D_lifetime_talous_kaikki D_lifetime_henkiterv_tuomio = M_D_lifetime_henkiterv_tuomio D_lifetime_liikenne_tuomio = M_D_lifetime_liikenne_tuomio
D_Lifetime_muu_rikos_3_tuomio = M_D_Lifetime_muu_rikos_3_tuomio D_Lifetime_muu_rikos_4_tuomio = M_D_Lifetime_muu_rikos_4_tuomio D_Lifetime_muu_rikos_5_tuomio = M_D_Lifetime_muu_rikos_5_tuomio D_Lifetime_DUI_tuomio = M_D_Lifetime_DUI_tuomio

D_lifetime_talous = M_D_lifetime_talous D_lifetime_henkiterv = M_D_lifetime_henkiterv D_lifetime_liikenne = M_D_lifetime_liikenne
D_Lifetime_muu_rikos_4 = M_D_Lifetime_muu_rikos_4

D_talous_tuomio = M_D_talous_tuomio D_talous_kaikki_tuomio = M_D_talous_kaikki_tuomio D_henkiterv_tuomio = M_D_henkiterv_tuomio D_liikenne_tuomio = M_D_liikenne_tuomio D_muu_rikos_3_tuomio = M_D_muu_rikos_3_tuomio
D_muu_rikos_4_tuomio = M_D_muu_rikos_4_tuomio D_muu_rikos_5_tuomio = M_D_muu_rikos_5_tuomio

D_Kirjanpitorikos_tuomio_2 = M_D_Kirjanpitorikos_tuomio_2 D_talous_tuomio_2 = M_D_talous_tuomio_2 D_talous_kaikki_tuomio_2 = M_D_talous_kaikki_tuomio_2
D_muu_rikos_3_tuomio_2 = M_D_muu_rikos_3_tuomio_2 D_muu_rikos_4_tuomio_2 = M_D_muu_rikos_4_tuomio_2 D_muu_rikos_5_tuomio_2 = M_D_muu_rikos_5_tuomio_2
D_liikenne_tuomio_2 = M_D_liikenne_tuomio_2

D_Kirjanpitorikos_kaikki_2 = M_D_Kirjanpitorikos_kaikki_2 D_talous_2 = M_D_talous_2 D_talous_kaikki_2 = M_D_talous_kaikki_2
D_muu_rikos_3_2 = M_D_muu_rikos_3_2 D_muu_rikos_4_2 = M_D_muu_rikos_4_2 D_muu_rikos_5_2 = M_D_muu_rikos_5_2

Viim_rikos_tvuosi = M_Viim_rikos_tvuosi Ens_muu_rikos_tvuosi = M_Ens_muu_rikos_tvuosi Ens_talousrikos_tvuosi = M_Ens_talousrikos_tvuosi Viim_muu_rikos_tvuosi = M_Viim_muu_rikos_tvuosi Viim_talousrikos_tvuosi = M_Viim_talousrikos_tvuosi

LN_TOTALINCOME = M_LN_TOTALINCOME
LN_CAPITALTOTAL = M_LN_CAPITALTOTAL
LN_SALARYTOTAL = M_LN_SALARYTOTAL

TOTALINCOME = M_TOTALINCOME
CAPITALTOTAL = M_CAPITALTOTAL
SALARYTOTAL = M_SALARYTOTAL

D_MARITAL_STATUS = M_D_MARITAL_STATUS Divorce = M_Divorce Divorce_prev_5_years = M_Divorce_prev_5_years CUM_Sum_Divorce = M_CUM_Sum_Divorce CUM_Sum_Married = M_CUM_Sum_Married
lifetime_sum_divorce = M_lifetime_sum_divorce

MAAKUNTA = M_MAAKUNTA
KUNTA = M_KUNTA

BIRTHYEAR = M_BIRTHYEAR MALE = M_MALE SALARYTOTAL = M_SALARYTOTAL LN_SALARYTOTAL = M_LN_SALARYTOTAL TOTALINCOME = M_TOTALINCOME

AGE = M_AGE BUSINESS_SOCIALDEG = M_BUSINESS_SOCIALDEG EDULEVEL = M_EDULEVEL LN_AGE = M_LN_AGE

D_Vanh_positio = M_D_Vanh_positio

CUM_Talous_kaikki_vankeus = M_CUM_Talous_kaikki_vankeus
CUM_Talous_kaikki_sakko = M_CUM_Talous_kaikki_sakko
CUM_Talous_kaikki_ehdol_vankeus = M_CUM_Talous_kaik_ehdol_vankeus
CUM_Talous_kaikki_ehdot_vankeus = M_CUM_Talous_kaik_ehdot_vankeus

CUM_muu_rikos_4_vankeus = M_CUM_muu_rikos_4_vankeus
CUM_muu_rikos_4_sakko = M_CUM_muu_rikos_4_sakko
CUM_muu_rikos_4_ehdol_vankeus = M_CUM_muu_rikos_4_ehdol_vankeus
CUM_muu_rikos_4_ehdot_vankeus = M_CUM_muu_rikos_4_ehdot_vankeus

D_Lifetime_Talous_kaikki_v = M_D_Lifetime_Talous_kaikki_v
D_Lifetime_Talous_kaikki_s = M_D_Lifetime_Talous_kaikki_s
D_Lifetime_Talous_kaikki_ehdol_v = M_D_Lifetime_Talous_kaik_ehdol_v
D_Lifetime_Talous_kaikki_ehdot_v = M_D_Lifetime_Talous_kaik_ehdot_v

D_Lifetime_muu_rikos_4_v = M_D_Lifetime_muu_rikos_4_v
D_Lifetime_muu_rikos_4_s = M_D_Lifetime_muu_rikos_4_s

D_Talous_kaikki_vankeus_2 = M_D_Talous_kaikki_vankeus_2
D_Talous_kaikki_sakko_2 = M_D_Talous_kaikki_sakko_2
D_Talous_kaikki_vankeus_tuomio_2 = M_D_Talous_kaikki_vankeus_tuom_2
D_Talous_kaikki_ehdol_vankeus_2 = M_D_Talous_kaik_ehdol_vankeus_2
D_Talous_kaikki_ehdot_vankeus_2 = M_D_Talous_kaik_ehdot_vankeus_2

D_muu_rikos_4_vankeus_2 = M_D_muu_rikos_4_vankeus_2
D_muu_rikos_4_sakko_2 = M_D_muu_rikos_4_sakko_2
D_muu_rikos_4_vankeus_tuomio_2 = M_D_muu_rikos_4_vankeus_tuomio_2
D_muu_rikos_4_ehdol_vankeus_2 = M_D_muu_rikos_4_ehdol_vankeus_2
D_muu_rikos_4_ehdot_vankeus_2 = M_D_muu_rikos_4_ehdot_vankeus_2

Lifetime_CUM_Talous_kaikki_v = M_Lt_CUM_Talous_kaikki_v
Lifetime_CUM_Talous_kaikki_s = M_Lt_CUM_Talous_kaikki_s
Ltime_CUM_Talous_kaikki_ehdol_v = M_Lt_CUM_Talous_kaikki_ehdol_v
Ltime_CUM_Talous_kaikki_ehdot_v = M_Lt_CUM_Talous_kaikki_ehdot_v

Lifetime_CUM_muu_rikos_4_v = M_Lt_CUM_muu_rikos_4_v
Lifetime_CUM_muu_rikos_4_s = M_Lt_CUM_muu_rikos_4_s

D_CUM_SUBSTANCE = M_D_CUM_SUBSTANCE
D_CUM_ALL_BUT_SUBS = M_D_CUM_ALL_BUT_SUBS
CUM_NALL_BUT_SUBS = M_CUM_NALL_BUT_SUBS
CUM_NSUBSTANCE = M_CUM_NSUBSTANCE

skunta = m_skunta
SOCIOECONOMIC_POSITION = M_SOCIOECONOMIC_POSITION RESIDENTIALFORM = M_RESIDENTIALFORM;

drop CUM_Vanh_positio;

run;

data Aidit_3;
merge aidit_2 vanh_omistusosuus demografiset_kieli_2;
by id;

if mukana = . then delete;

rename id = M_id
firm1 = M_firm1 firm2 = M_firm2 firm3 = M_firm3 firm4 = M_firm4 firm5 = M_firm5 firm6 = M_firm6 firm7 = M_firm7 firm8 = M_firm8 firm9 = M_firm9 firm10 = M_firm10
firm11 = M_firm11 firm12 = M_firm12 firm13 = M_firm13 firm14 = M_firm14 firm15 = M_firm15 firm16 = M_firm16 firm17 = M_firm17 firm18 = M_firm18 firm19 = M_firm19 firm20 = M_firm20
firm21 = M_firm21 firm22 = M_firm22 firm23 = M_firm23 firm24 = M_firm24 firm25 = M_firm25 firm26 = M_firm26 firm27 = M_firm27 firm28 = M_firm28 firm29 = M_firm29 firm30 = M_firm30
firm31 = M_firm31 firm32 = M_firm32 firm33 = M_firm33 firm34 = M_firm34 firm35 = M_firm35 firm36 = M_firm36 firm37 = M_firm37 firm38 = M_firm38 firm39 = M_firm39 firm40 = M_firm40
firm41 = M_firm41 firm42 = M_firm42 firm43 = M_firm43 firm44 = M_firm44 firm45 = M_firm45 firm46 = M_firm46 firm47 = M_firm47 NATIVE_LANGUAGE = M_NATIVE_LANGUAGE;

run;

* Fathers;

data Isat_2;
merge Isat demografiset_2 koulutus tulodata kirjanpitorikos_yt hilmot vanh_positions_3;
by id year;

if male = . then delete;
if birthyear = . then delete;
if id = '' then delete;
if mukana = . then delete;
if mukaan = . then delete;

if BUSINESS_SOCIALDEG = . then BUSINESS_SOCIALDEG = 0;
if EDULEVEL = . then EDULEVEL = 0;

LN_AGE = log(AGE+1);

if D_Lifetime_Kirjpitorikos_tuomio = . then D_Lifetime_Kirjpitorikos_tuomio = 0;
if D_Lifetime_Kirjpitorikos = . then D_Lifetime_Kirjpitorikos = 0;
if D_Lifetime_Muu_rikos_3_tuomio = . then D_Lifetime_Muu_rikos_3_tuomio = 0;
if D_Lifetime_Muu_rikos_4_tuomio = . then D_Lifetime_Muu_rikos_4_tuomio = 0;
if D_Lifetime_Muu_rikos_5_tuomio = . then D_Lifetime_Muu_rikos_5_tuomio = 0;
if D_Lifetime_Talous_tuomio = . then D_Lifetime_Talous_tuomio = 0;
if D_Lifetime_Talous_kaikki = . then D_Lifetime_Talous_kaikki = 0;
if D_Lifetime_Talous_kaikki_tuomio = . then D_Lifetime_Talous_kaikki_tuomio = 0;
if D_Lifetime_Henkiterv = . then D_Lifetime_Henkiterv = 0;
if D_Lifetime_Henkiterv_tuomio = . then D_Lifetime_Henkiterv_tuomio = 0;
if D_Lifetime_Liikenne = . then D_Lifetime_Liikenne = 0;
if D_Lifetime_Liikenne_tuomio = . then D_Lifetime_Liikenne_tuomio = 0;
if D_Lifetime_DUI_tuomio = . then D_Lifetime_DUI_tuomio = 0;
if D_Lifetime_Finan_fraud = . then D_Lifetime_Finan_fraud = 0;
if D_Lifetime_Tax_fraud = . then D_Lifetime_Tax_fraud = 0;
if D_Lifetime_other_fraud = . then D_Lifetime_other_fraud = 0;

if D_Lifetime_Talous_kaikki_v = . then D_Lifetime_Talous_kaikki_v = 0;
if D_Lifetime_Talous_kaikki_ehdol_v = . then D_Lifetime_Talous_kaikki_ehdol_v = 0;
if D_Lifetime_Talous_kaikki_ehdot_v = . then D_Lifetime_Talous_kaikki_ehdot_v = 0;
if D_Lifetime_muu_rikos_4_v = . then D_Lifetime_muu_rikos_4_v = 0;

if Lifetime_CUM_Muu3 = . then Lifetime_CUM_Muu3 = 0;
if Lifetime_CUM_Muu4 = . then Lifetime_CUM_Muu4 = 0;
if Lifetime_CUM_Muu5 = . then Lifetime_CUM_Muu5 = 0;
if Lifetime_CUM_Talous = . then Lifetime_CUM_Talous = 0;
if Lifetime_CUM_Talous_kaikki = . then Lifetime_CUM_Talous_kaikki = 0;
if Lifetime_CUM_Henkiterv = . then Lifetime_CUM_Henkiterv = 0;
if Lifetime_CUM_Liikenne = . then Lifetime_CUM_Liikenne = 0;
if Lifetime_CUM_KPrikos_kaikki = . then Lifetime_CUM_KPrikos_kaikki = 0;
if Lifetime_CUM_Finan_rep_fraud = . then Lifetime_CUM_Finan_rep_fraud = 0;
if Lifetime_CUM_Tax_relat_fraud = . then Lifetime_CUM_Tax_relat_fraud = 0;
if Lifetime_CUM_Other_finan_crime = . then Lifetime_CUM_Other_finan_crime = 0;

if Lifetime_CUM_Talous_kaikki_v = . then Lifetime_CUM_Talous_kaikki_v = 0;
if Lifetime_CUM_Talous_kaikki_s = . then Lifetime_CUM_Talous_kaikki_s = 0;
if Ltime_CUM_Talous_kaikki_ehdol_v = . then Ltime_CUM_Talous_kaikki_ehdol_v = 0;
if Ltime_CUM_Talous_kaikki_ehdot_v = . then Ltime_CUM_Talous_kaikki_ehdot_v = 0;
if Lifetime_CUM_muu_rikos_4_v = . then Lifetime_CUM_muu_rikos_4_v = 0;
if Lifetime_CUM_muu_rikos_4_s = . then Lifetime_CUM_muu_rikos_4_s = 0;

if D_Kirjanpitorikos_tuomio = . then D_Kirjanpitorikos_tuomio = 0;
if D_Kirjanpitorikos_tuomio_2 = . then D_Kirjanpitorikos_tuomio_2 = 0;
if D_Kirjanpitorikos_kaikki_2 = . then D_Kirjanpitorikos_kaikki_2 = 0;
if D_Muu_rikos_3_tuomio = . then D_Muu_rikos_3_tuomio = 0;
if D_Muu_rikos_4_tuomio = . then D_Muu_rikos_4_tuomio = 0;
if D_Muu_rikos_5_tuomio = . then D_Muu_rikos_5_tuomio = 0;
if D_Muu_rikos_3_tuomio_2 = . then D_Muu_rikos_3_tuomio_2 = 0;
if D_Muu_rikos_4_tuomio_2 = . then D_Muu_rikos_4_tuomio_2 = 0;
if D_Muu_rikos_5_tuomio_2 = . then D_Muu_rikos_5_tuomio_2 = 0;
if D_Muu_rikos_3_2 = . then D_Muu_rikos_3_2 = 0;
if D_Muu_rikos_4_2 = . then D_Muu_rikos_4_2 = 0;
if D_Muu_rikos_5_2 = . then D_Muu_rikos_5_2 = 0;
if D_Talous_tuomio = . then D_Talous_tuomio = 0;
if D_Talous_kaikki_tuomio = . then D_Talous_kaikki_tuomio = 0;
if D_Talous_tuomio_2 = . then D_Talous_tuomio_2 = 0;
if D_Talous_kaikki_tuomio_2 = . then D_Talous_kaikki_tuomio_2 = 0;
if D_Talous_2 = . then D_Talous_2 = 0;
if D_Talous_kaikki_2 = . then D_Talous_kaikki_2 = 0;
if D_Henkiterv_tuomio = . then D_Henkiterv_tuomio = 0;
if D_Liikenne_tuomio = . then D_Liikenne_tuomio = 0;
if D_Liikenne_tuomio_2 = . then D_Liikenne_tuomio_2 = 0;

if D_Talous_kaikki_vankeus_2 = . then D_Talous_kaikki_vankeus_2 = 0;
if D_Talous_kaikki_sakko_2 = . then D_Talous_kaikki_sakko_2 = 0;
if D_Talous_kaikki_vankeus_tuomio_2 = . then D_Talous_kaikki_vankeus_tuomio_2 = 0;
if D_Talous_kaikki_ehdol_vankeus_2 = . then D_Talous_kaikki_ehdol_vankeus_2 = 0;
if D_Talous_kaikki_ehdot_vankeus_2 = . then D_Talous_kaikki_ehdot_vankeus_2 = 0;

if D_muu_rikos_4_vankeus_2 = . then D_muu_rikos_4_vankeus_2 = 0;
if D_muu_rikos_4_sakko_2 = . then D_muu_rikos_4_sakko_2 = 0;
if D_muu_rikos_4_vankeus_tuomio_2 = . then D_muu_rikos_4_vankeus_tuomio_2 = 0;
if D_muu_rikos_4_ehdol_vankeus_2 = . then D_muu_rikos_4_ehdol_vankeus_2 = 0;
if D_muu_rikos_4_ehdot_vankeus_2 = . then D_muu_rikos_4_ehdot_vankeus_2 = 0;

if CUM_Muu3_tuomio = . then CUM_muu3_tuomio = 0;
if CUM_Muu4_tuomio = . then CUM_muu4_tuomio = 0;
if CUM_Muu5_tuomio = . then CUM_muu5_tuomio = 0;
if CUM_Talous_tuomio = . then CUM_Talous_tuomio = 0;
if CUM_Talous_kaikki_tuomio = . then CUM_Talous_kaikki_tuomio = 0;
if CUM_Liikenne_tuomio = . then CUM_Liikenne_tuomio = 0;
if CUM_Kirjanpitorikos_tuomio = . then CUM_Kirjanpitorikos_tuomio = 0;

if CUM_Muu3 = . then CUM_muu3 = 0;
if CUM_Muu4 = . then CUM_muu4 = 0;
if CUM_Muu5 = . then CUM_muu5 = 0;
if CUM_Talous = . then CUM_Talous = 0;
if CUM_Talous_kaikki = . then CUM_Talous_kaikki = 0;
if CUM_Kirjanpitorikos_kaikki = . then CUM_Kirjanpitorikos_kaikki = 0;
if CUM_Liikenne = . then CUM_Liikenne = 0;
if CUM_Henkiterveys = . then CUM_Henkiterveys = 0;
if CUM_Finan_rep_fraud = . then CUM_Finan_rep_fraud = 0;
if CUM_Tax_relat_fraud = . then CUM_Tax_relat_fraud = 0;
if CUM_other_finan_crime = . then CUM_other_finan_crime = 0;

if CUM_Talous_kaikki_vankeus = . then CUM_Talous_kaikki_vankeus = 0;
if CUM_Talous_kaikki_sakko = . then CUM_Talous_kaikki_sakko = 0;
if CUM_Talous_kaikki_ehdol_vankeus = . then CUM_Talous_kaikki_ehdol_vankeus = 0;
if CUM_Talous_kaikki_ehdot_vankeus = . then CUM_Talous_kaikki_ehdot_vankeus = 0;

if CUM_muu_rikos_4_vankeus = . then CUM_muu_rikos_4_vankeus = 0;
if CUM_muu_rikos_4_sakko = . then CUM_muu_rikos_4_sakko = 0;
if CUM_muu_rikos_4_ehdol_vankeus = . then CUM_muu_rikos_4_ehdol_vankeus = 0;
if CUM_muu_rikos_4_ehdot_vankeus = . then CUM_muu_rikos_4_ehdot_vankeus = 0;

If CUM_Vanh_positio = . then CUM_Vanh_positio = 0;

D_Vanh_positio = 0;
if CUM_Vanh_positio > 0 then D_Vanh_positio = 1;

if D_CUM_SUBSTANCE = . then D_CUM_SUBSTANCE = 0;
if D_CUM_ALL_BUT_SUBS = . then D_CUM_ALL_BUT_SUBS = 0;
if CUM_NALL_BUT_SUBS = . then CUM_NALL_BUT_SUBS = 0;
if CUM_NSUBSTANCE = . then CUM_NSUBSTANCE = 0;


rename CUM_Muu3_tuomio = F_CUM_muu3_tuomio CUM_Muu4_tuomio = F_CUM_muu4_tuomio CUM_Muu5_tuomio = F_CUM_muu5_tuomio CUM_Talous_tuomio = F_CUM_Talous_tuomio CUM_Talous_kaikki_tuomio = F_CUM_Talous_kaikki_tuomio
CUM_Liikenne_tuomio = F_CUM_Liikenne_tuomio CUM_Liikenne = F_CUM_Liikenne CUM_Kirjanpitorikos_tuomio = F_CUM_Kirjanpitorikos_tuomio CUM_Henkiterveys = F_CUM_Henkiterveys

CUM_Muu3 = F_CUM_muu3 CUM_Muu4 = F_CUM_muu4 CUM_Muu5 = F_CUM_muu5 CUM_Talous = F_CUM_Talous CUM_Talous_kaikki = F_CUM_Talous_kaikki
CUM_Kirjanpitorikos_kaikki = F_CUM_Kirjanpitorikos_kaikki CUM_Finan_rep_fraud = F_CUM_Finan_rep_fraud CUM_Tax_relat_fraud = F_CUM_Tax_relat_fraud
CUM_other_finan_crime = F_CUM_other_finan_crime

D_Lifetime_Kirjpitorikos_tuomio = F_D_Lifetime_KPrikos_tuomio D_lifetime_Kirjpitorikos = F_D_lifetime_Kirjpitorikos

D_Lifetime_Finan_fraud = F_D_Lifetime_Finan_fraud D_Lifetime_Tax_fraud = F_D_Lifetime_Tax_fraud D_Lifetime_other_fraud  = F_D_Lifetime_other_fraud

Lifetime_CUM_Muu3 = F_Lifetime_CUM_Muu3
Lifetime_CUM_Muu4 = F_Lifetime_CUM_Muu4
Lifetime_CUM_Muu5 = F_Lifetime_CUM_Muu5
Lifetime_CUM_Talous = F_Lifetime_CUM_Talous
Lifetime_CUM_Talous_kaikki = F_Lifetime_CUM_Talous_kaikki
Lifetime_CUM_Henkiterv = F_Lifetime_CUM_Henkiterv
Lifetime_CUM_Liikenne = F_Lifetime_CUM_Liikenne
Lifetime_CUM_KPrikos_kaikki = F_Lifetime_CUM_KPrikos_kaikki
Lifetime_CUM_Finan_rep_fraud = F_Lifetime_CUM_Finan_rep_fraud
Lifetime_CUM_Tax_relat_fraud = F_Lifetime_CUM_Tax_relat_fraud
Lifetime_CUM_Other_finan_crime = F_Lifetime_CUM_Other_finan_crime

D_Kirjanpitorikos_tuomio = F_D_Kirjanpitorikos_tuomio

D_lifetime_talous_tuomio = F_D_lifetime_talous_tuomio D_lifetime_talous_kaikki_tuomio = F_D_lifetime_talous_kaik_tuomio D_lifetime_talous_kaikki = F_D_lifetime_talous_kaikki D_lifetime_henkiterv_tuomio = F_D_lifetime_henkiterv_tuomio D_lifetime_liikenne_tuomio = F_D_lifetime_liikenne_tuomio
D_Lifetime_muu_rikos_3_tuomio = F_D_Lifetime_muu_rikos_3_tuomio D_Lifetime_muu_rikos_4_tuomio = F_D_Lifetime_muu_rikos_4_tuomio D_Lifetime_muu_rikos_5_tuomio = F_D_Lifetime_muu_rikos_5_tuomio D_Lifetime_DUI_tuomio = F_D_Lifetime_DUI_tuomio

D_lifetime_talous = F_D_lifetime_talous D_lifetime_henkiterv = F_D_lifetime_henkiterv D_lifetime_liikenne = F_D_lifetime_liikenne
D_Lifetime_muu_rikos_4 = F_D_Lifetime_muu_rikos_4

D_talous_tuomio = F_D_talous_tuomio D_talous_kaikki_tuomio = F_D_talous_kaikki_tuomio D_henkiterv_tuomio = F_D_henkiterv_tuomio D_liikenne_tuomio = F_D_liikenne_tuomio D_muu_rikos_3_tuomio = F_D_muu_rikos_3_tuomio
D_muu_rikos_4_tuomio = F_D_muu_rikos_4_tuomio D_muu_rikos_5_tuomio = F_D_muu_rikos_5_tuomio

D_Kirjanpitorikos_tuomio_2 = F_D_Kirjanpitorikos_tuomio_2 D_talous_tuomio_2 = F_D_talous_tuomio_2 D_talous_kaikki_tuomio_2 = F_D_talous_kaikki_tuomio_2
D_muu_rikos_3_tuomio_2 = F_D_muu_rikos_3_tuomio_2 D_muu_rikos_4_tuomio_2 = F_D_muu_rikos_4_tuomio_2 D_muu_rikos_5_tuomio_2 = F_D_muu_rikos_5_tuomio_2
D_liikenne_tuomio_2 = F_D_liikenne_tuomio_2

D_Kirjanpitorikos_kaikki_2 = F_D_Kirjanpitorikos_kaikki_2 D_talous_2 = F_D_talous_2 D_talous_kaikki_2 = F_D_talous_kaikki_2
D_muu_rikos_3_2 = F_D_muu_rikos_3_2 D_muu_rikos_4_2 = F_D_muu_rikos_4_2 D_muu_rikos_5_2 = F_D_muu_rikos_5_2

Viim_rikos_tvuosi = F_Viim_rikos_tvuosi Ens_muu_rikos_tvuosi = F_Ens_muu_rikos_tvuosi Ens_talousrikos_tvuosi = F_Ens_talousrikos_tvuosi Viim_muu_rikos_tvuosi = F_Viim_muu_rikos_tvuosi Viim_talousrikos_tvuosi = F_Viim_talousrikos_tvuosi

LN_TOTALINCOME = F_LN_TOTALINCOME
LN_CAPITALTOTAL = F_LN_CAPITALTOTAL
LN_SALARYTOTAL = F_LN_SALARYTOTAL

TOTALINCOME = F_TOTALINCOME
CAPITALTOTAL = F_CAPITALTOTAL
SALARYTOTAL = F_SALARYTOTAL

D_MARITAL_STATUS = F_D_MARITAL_STATUS Divorce = F_Divorce Divorce_prev_5_years = F_Divorce_prev_5_years CUM_Sum_Divorce = F_CUM_Sum_Divorce CUM_Sum_Married = F_CUM_Sum_Married
lifetime_sum_divorce = F_lifetime_sum_divorce

MAAKUNTA = F_MAAKUNTA
KUNTA = F_KUNTA

BIRTHYEAR = F_BIRTHYEAR MALE = F_MALE SALARYTOTAL = F_SALARYTOTAL LN_SALARYTOTAL = F_LN_SALARYTOTAL TOTALINCOME = F_TOTALINCOME

AGE = F_AGE BUSINESS_SOCIALDEG = F_BUSINESS_SOCIALDEG EDULEVEL = F_EDULEVEL LN_AGE = F_LN_AGE

D_Vanh_positio = F_D_Vanh_positio

CUM_Talous_kaikki_vankeus = F_CUM_Talous_kaikki_vankeus
CUM_Talous_kaikki_sakko = F_CUM_Talous_kaikki_sakko
CUM_Talous_kaikki_ehdol_vankeus = F_CUM_Talous_kaik_ehdol_vankeus
CUM_Talous_kaikki_ehdot_vankeus = F_CUM_Talous_kaik_ehdot_vankeus

CUM_muu_rikos_4_vankeus = F_CUM_muu_rikos_4_vankeus
CUM_muu_rikos_4_sakko = F_CUM_muu_rikos_4_sakko
CUM_muu_rikos_4_ehdol_vankeus = F_CUM_muu_rikos_4_ehdol_vankeus
CUM_muu_rikos_4_ehdot_vankeus = F_CUM_muu_rikos_4_ehdot_vankeus

D_Lifetime_Talous_kaikki_v = F_D_Lifetime_Talous_kaikki_v
D_Lifetime_Talous_kaikki_s = F_D_Lifetime_Talous_kaikki_s
D_Lifetime_Talous_kaikki_ehdol_v = F_D_Lifetime_Talous_kaik_ehdol_v
D_Lifetime_Talous_kaikki_ehdot_v = F_D_Lifetime_Talous_kaik_ehdot_v

D_Lifetime_muu_rikos_4_v = F_D_Lifetime_muu_rikos_4_v
D_Lifetime_muu_rikos_4_s = F_D_Lifetime_muu_rikos_4_s

D_Talous_kaikki_vankeus_2 = F_D_Talous_kaikki_vankeus_2
D_Talous_kaikki_sakko_2 = F_D_Talous_kaikki_sakko_2
D_Talous_kaikki_vankeus_tuomio_2 = F_D_Talous_kaikki_vankeus_tuom_2
D_Talous_kaikki_ehdol_vankeus_2 = F_D_Talous_kaik_ehdol_vankeus_2
D_Talous_kaikki_ehdot_vankeus_2 = F_D_Talous_kaik_ehdot_vankeus_2

D_muu_rikos_4_vankeus_2 = F_D_muu_rikos_4_vankeus_2
D_muu_rikos_4_sakko_2 = F_D_muu_rikos_4_sakko_2
D_muu_rikos_4_vankeus_tuomio_2 = F_D_muu_rikos_4_vankeus_tuomio_2
D_muu_rikos_4_ehdol_vankeus_2 = F_D_muu_rikos_4_ehdol_vankeus_2
D_muu_rikos_4_ehdot_vankeus_2 = F_D_muu_rikos_4_ehdot_vankeus_2

Lifetime_CUM_Talous_kaikki_v = F_Lt_CUM_Talous_kaikki_v
Lifetime_CUM_Talous_kaikki_s = F_Lt_CUM_Talous_kaikki_s
Ltime_CUM_Talous_kaikki_ehdol_v = F_Lt_CUM_Talous_kaikki_ehdol_v
Ltime_CUM_Talous_kaikki_ehdot_v = F_Lt_CUM_Talous_kaikki_ehdot_v

Lifetime_CUM_muu_rikos_4_v = F_Lt_CUM_muu_rikos_4_v
Lifetime_CUM_muu_rikos_4_s = F_Lt_CUM_muu_rikos_4_s

D_CUM_SUBSTANCE = F_D_CUM_SUBSTANCE
D_CUM_ALL_BUT_SUBS = F_D_CUM_ALL_BUT_SUBS
CUM_NALL_BUT_SUBS = F_CUM_NALL_BUT_SUBS
CUM_NSUBSTANCE = F_CUM_NSUBSTANCE

skunta = f_skunta
SOCIOECONOMIC_POSITION = F_SOCIOECONOMIC_POSITION RESIDENTIALFORM = F_RESIDENTIALFORM;

drop CUM_Vanh_positio;

run;

data isat_3;
merge isat_2 vanh_omistusosuus demografiset_kieli_2;
by id;

if mukana = . then delete;

rename id = f_id
firm1 = F_firm1 firm2 = F_firm2 firm3 = F_firm3 firm4 = F_firm4 firm5 = F_firm5 firm6 = F_firm6 firm7 = F_firm7 firm8 = F_firm8 firm9 = F_firm9 firm10 = F_firm10
firm11 = F_firm11 firm12 = F_firm12 firm13 = F_firm13 firm14 = F_firm14 firm15 = F_firm15 firm16 = F_firm16 firm17 = F_firm17 firm18 = F_firm18 firm19 = F_firm19 firm20 = F_firm20
firm21 = F_firm21 firm22 = F_firm22 firm23 = F_firm23 firm24 = F_firm24 firm25 = F_firm25 firm26 = F_firm26 firm27 = F_firm27 firm28 = F_firm28 firm29 = F_firm29 firm30 = F_firm30
firm31 = F_firm31 firm32 = F_firm32 firm33 = F_firm33 firm34 = F_firm34 firm35 = F_firm35 firm36 = F_firm36 firm37 = F_firm37 firm38 = F_firm38 firm39 = F_firm39 firm40 = F_firm40
firm41 = F_firm41 firm42 = F_firm42 firm43 = F_firm43 firm44 = F_firm44 firm45 = F_firm45 firm46 = F_firm46 firm47 = F_firm47 NATIVE_LANGUAGE = F_NATIVE_LANGUAGE;

run;


* Merges mothers' and fathers' data into one dataset;

proc sort data = kaikki_2;
by m_id year;
run;

proc sort data = aidit_3;
by m_id year;
run;

data kaikki_3;
merge kaikki_2 aidit_3;
by m_id year;

run;

proc sort data = kaikki_3;
by f_id year;
run;

proc sort data = isat_3;
by f_id year;
run;

data kaikki_4;
merge kaikki_3 isat_3;
by f_id year;

if F_AGE = . and M_AGE = . then delete;

run;

proc sort nodupkey data = kaikki_4;
by id year;

run;

* Creates parents' joint variables from mothers' and fathers' individual variables;

data kaikki_5;
set kaikki_4;

P_D_Lifetime_KPrikos_tuomio = 0;
P_D_Lifetime_muu_rikos_3_tuomio = 0;
P_D_Lifetime_muu_rikos_4_tuomio = 0;
P_D_Lifetime_muu_rikos_5_tuomio = 0;
P_D_Lifetime_talous_tuomio = 0;
P_D_Lifetime_talous_kaik_tuomio = 0;
P_D_Lifetime_henkiterv_tuomio = 0;
P_D_Lifetime_liikenne_tuomio = 0;

P_D_Lifetime_Kirjpitorikos = 0;
P_D_Lifetime_muu_rikos_3 = 0;
P_D_Lifetime_muu_rikos_4 = 0;
P_D_Lifetime_muu_rikos_5 = 0;
P_D_Lifetime_talous = 0;
P_D_Lifetime_talous_kaikki = 0;
P_D_Lifetime_henkiterv = 0;
P_D_Lifetime_liikenne = 0;

P_D_Kirjanpitorikos_tuomio = 0;
P_D_muu_rikos_3_tuomio = 0;
P_D_muu_rikos_4_tuomio = 0;
P_D_muu_rikos_5_tuomio = 0;
P_D_talous_tuomio = 0;
P_D_talous_kaikki_tuomio = 0;
P_D_henkiterv_tuomio = 0;
P_D_liikenne_tuomio = 0;

P_D_Kirjanpitorikos_tuomio_2 = 0;
P_D_muu_rikos_4_tuomio_2 = 0;
P_D_muu_rikos_5_tuomio_2 = 0;
P_D_talous_tuomio_2 = 0;
P_D_talous_kaikki_tuomio_2 = 0;
P_D_liikenne_tuomio_2 = 0;

P_D_Kirjanpitorikos_kaikki_2 = 0;
P_D_muu_rikos_4_2 = 0;
P_D_muu_rikos_5_2 = 0;
P_D_talous_2 = 0;
P_D_talous_kaikki_2 = 0;

P_CUM_Muu3_tuomio = 0;
P_CUM_Muu4_tuomio = 0;
P_CUM_Muu5_tuomio = 0;
P_CUM_Talous_tuomio = 0;
P_CUM_Talous_kaikki_tuomio = 0;
P_CUM_Liikenne_tuomio = 0;
P_CUM_Kirjanpitorikos_tuomio = 0;

P_CUM_Muu3 = 0;
P_CUM_Muu4 = 0;
P_CUM_Muu5 = 0;
P_CUM_Talous = 0;
P_CUM_Talous_kaikki = 0;
P_CUM_Kirjanpitorikos_kaikki = 0;
P_CUM_Liikenne = 0;
P_CUM_Henkiterveys = 0;
P_CUM_Finan_rep_fraud  = 0;
P_CUM_Tax_relat_fraud = 0;
P_CUM_other_finan_crime = 0;

P_D_Lifetime_Talous_kaikki_v = 0;
P_D_Lifetime_Talous_kaikki_s = 0;
P_D_Lifetime_muu_rikos_4_v = 0;
P_D_Lifetime_muu_rikos_4_s = 0;

P_D_Talous_kaikki_vankeus_2 = 0;
P_D_Talous_kaikki_sakko_2 = 0;
P_D_Talous_kaikki_vankeus_tuom_2 = 0;
P_D_Talous_kaik_ehdol_vankeus_2 = 0;
P_D_Talous_kaik_ehdot_vankeus_2 = 0;

P_D_muu_rikos_4_vankeus_2 = 0;
P_D_muu_rikos_4_sakko_2 = 0;
P_D_muu_rikos_4_vankeus_tuomio_2 = 0;
P_D_muu_rikos_4_ehdol_vankeus_2 = 0;
P_D_muu_rikos_4_ehdot_vankeus_2 = 0;

P_D_CUM_SUBSTANCE = 0;
P_D_CUM_ALL_BUT_SUBS = 0;
P_CUM_NALL_BUT_SUBS = 0;
P_CUM_NSUBSTANCE = 0;

P_CUM_NALL_BUT_SUBS = M_CUM_NALL_BUT_SUBS + F_CUM_NALL_BUT_SUBS;
P_CUM_NSUBSTANCE = M_CUM_NSUBSTANCE + F_CUM_NSUBSTANCE;

if M_D_CUM_SUBSTANCE = 1 or F_D_CUM_SUBSTANCE = 1 then P_D_CUM_SUBSTANCE = 1;
if M_D_CUM_ALL_BUT_SUBS = 1 or F_D_CUM_ALL_BUT_SUBS = 1 then P_D_CUM_ALL_BUT_SUBS = 1;

if M_CUM_NSUBSTANCE = . then P_CUM_NSUBSTANCE = F_CUM_NSUBSTANCE;
if F_CUM_NSUBSTANCE = . then P_CUM_NSUBSTANCE = M_CUM_NSUBSTANCE;

if M_CUM_NALL_BUT_SUBS = . then P_CUM_NALL_BUT_SUBS = F_CUM_NALL_BUT_SUBS;
if F_CUM_NALL_BUT_SUBS = . then P_CUM_NALL_BUT_SUBS = M_CUM_NALL_BUT_SUBS;

P_CUM_Muu3_tuomio = M_CUM_Muu3_tuomio + F_CUM_Muu3_tuomio;
P_CUM_Muu4_tuomio = M_CUM_Muu4_tuomio + F_CUM_Muu4_tuomio;
P_CUM_Muu5_tuomio = M_CUM_Muu5_tuomio + F_CUM_Muu5_tuomio;
P_CUM_Talous_tuomio = M_CUM_Talous_tuomio + F_CUM_Talous_tuomio;
P_CUM_Talous_kaikki_tuomio = M_CUM_Talous_kaikki_tuomio + F_CUM_Talous_kaikki_tuomio;
P_CUM_Liikenne_tuomio = M_CUM_Liikenne_tuomio + F_CUM_Liikenne_tuomio;
P_CUM_Kirjanpitorikos_tuomio = M_CUM_Kirjanpitorikos_tuomio + F_CUM_Kirjanpitorikos_tuomio;

P_CUM_Muu3 = M_CUM_Muu3 + F_CUM_Muu3;
P_CUM_Muu4 = M_CUM_Muu4 + F_CUM_Muu4;
P_CUM_Muu5 = M_CUM_Muu5 + F_CUM_Muu5;
P_CUM_Talous = M_CUM_Talous + F_CUM_Talous;
P_CUM_Talous_kaikki = M_CUM_Talous_kaikki + F_CUM_Talous_kaikki;
P_CUM_Kirjanpitorikos_kaikki = M_CUM_Kirjanpitorikos_kaikki + F_CUM_Kirjanpitorikos_kaikki;
P_CUM_Liikenne = M_CUM_Liikenne + F_CUM_Liikenne;
P_CUM_henkiterveys = M_CUM_henkiterveys + F_CUM_henkiterveys;
P_CUM_Finan_rep_fraud = M_CUM_Finan_rep_fraud + F_CUM_Finan_rep_fraud;
P_CUM_Tax_relat_fraud = M_CUM_Tax_relat_fraud + F_CUM_Tax_relat_fraud;
P_CUM_other_finan_crime = M_CUM_other_finan_crime + F_CUM_other_finan_crime;

if M_D_Talous_kaikki_vankeus_2 = 1 or F_D_Talous_kaikki_vankeus_2 = 1 then P_D_Talous_kaikki_vankeus_2 = 1;
if M_D_Talous_kaikki_sakko_2 = 1 or F_D_Talous_kaikki_sakko_2 = 1 then P_D_Talous_kaikki_sakko_2 = 1;
if M_D_Talous_kaikki_vankeus_tuom_2 = 1 or F_D_Talous_kaikki_vankeus_tuom_2 = 1 then P_D_Talous_kaikki_vankeus_tuom_2 = 1;
if M_D_Talous_kaik_ehdol_vankeus_2 = 1 or F_D_Talous_kaik_ehdol_vankeus_2 = 1 then P_D_Talous_kaik_ehdol_vankeus_2 = 1;
if M_D_Talous_kaik_ehdot_vankeus_2 = 1 or F_D_Talous_kaik_ehdot_vankeus_2 = 1 then P_D_Talous_kaik_ehdot_vankeus_2 = 1;
if M_D_muu_rikos_4_vankeus_2 = 1 or F_D_muu_rikos_4_vankeus_2 = 1 then P_D_muu_rikos_4_vankeus_2 = 1;
if M_D_muu_rikos_4_sakko_2 = 1 or F_D_muu_rikos_4_sakko_2 = 1 then P_D_muu_rikos_4_sakko_2 = 1;
if M_D_muu_rikos_4_vankeus_tuomio_2 = 1 or F_D_muu_rikos_4_vankeus_tuomio_2 = 1 then P_D_muu_rikos_4_vankeus_tuomio_2 = 1;
if M_D_muu_rikos_4_ehdol_vankeus_2 = 1 or F_D_muu_rikos_4_ehdol_vankeus_2 = 1 then P_D_muu_rikos_4_ehdol_vankeus_2 = 1;
if M_D_muu_rikos_4_ehdot_vankeus_2 = 1 or F_D_muu_rikos_4_ehdot_vankeus_2 = 1 then P_D_muu_rikos_4_ehdot_vankeus_2 = 1;

if M_D_Lifetime_Talous_kaikki_v = 1 or F_D_Lifetime_Talous_kaikki_v = 1 then P_D_Lifetime_Talous_kaikki_v = 1;
if M_D_Lifetime_Talous_kaikki_s = 1 or F_D_Lifetime_Talous_kaikki_s = 1 then P_D_Lifetime_Talous_kaikki_s = 1;

if M_D_Lifetime_muu_rikos_4_v = 1 or F_D_Lifetime_muu_rikos_4_v = 1 then P_D_Lifetime_muu_rikos_4_v = 1;
if M_D_Lifetime_muu_rikos_4_s = 1 or F_D_Lifetime_muu_rikos_4_s = 1 then P_D_Lifetime_muu_rikos_4_s = 1;

if M_CUM_Muu3_tuomio = . then P_CUM_Muu3_tuomio = F_CUM_Muu3_tuomio;
if M_CUM_Muu4_tuomio = . then P_CUM_Muu4_tuomio = F_CUM_Muu4_tuomio;
if M_CUM_Muu5_tuomio = . then P_CUM_Muu5_tuomio = F_CUM_Muu5_tuomio;
if M_CUM_Talous_tuomio = . then P_CUM_Talous_tuomio = F_CUM_Talous_tuomio;
if M_CUM_Talous_kaikki_tuomio = . then P_CUM_Talous_kaikki_tuomio = F_CUM_Talous_kaikki_tuomio;
if M_CUM_Liikenne_tuomio = . then P_CUM_Liikenne_tuomio = F_CUM_Liikenne_tuomio;
if M_CUM_Kirjanpitorikos_tuomio = . then P_CUM_Kirjanpitorikos_tuomio = F_CUM_Kirjanpitorikos_tuomio;

if F_CUM_Muu3_tuomio = . then P_CUM_Muu3_tuomio = M_CUM_Muu3_tuomio;
if F_CUM_Muu4_tuomio = . then P_CUM_Muu4_tuomio = M_CUM_Muu4_tuomio;
if F_CUM_Muu5_tuomio = . then P_CUM_Muu5_tuomio = M_CUM_Muu5_tuomio;
if F_CUM_Talous_tuomio = . then P_CUM_Talous_tuomio = M_CUM_Talous_tuomio;
if F_CUM_Talous_kaikki_tuomio = . then P_CUM_Talous_kaikki_tuomio = M_CUM_Talous_kaikki_tuomio;
if F_CUM_Liikenne_tuomio = . then P_CUM_Liikenne_tuomio = M_CUM_Liikenne_tuomio;
if F_CUM_Kirjanpitorikos_tuomio = . then P_CUM_Kirjanpitorikos_tuomio = M_CUM_Kirjanpitorikos_tuomio;

if M_CUM_Muu3 = . then P_CUM_Muu3 = F_CUM_Muu3;
if M_CUM_Muu4 = . then P_CUM_Muu4 = F_CUM_Muu4;
if M_CUM_Muu5 = . then P_CUM_Muu5 = F_CUM_Muu5;
if M_CUM_Talous = . then P_CUM_Talous = F_CUM_Talous;
if M_CUM_Talous_kaikki = . then P_CUM_Talous_kaikki = F_CUM_Talous_kaikki;
if M_CUM_Kirjanpitorikos_kaikki = . then P_CUM_Kirjanpitorikos_kaikki = F_CUM_Kirjanpitorikos_kaikki;
if M_CUM_Liikenne = . then P_CUM_Liikenne = F_CUM_Liikenne;
if M_CUM_henkiterveys = . then P_CUM_henkiterveys = F_CUM_henkiterveys;
if M_CUM_Finan_rep_fraud = . then P_CUM_Finan_rep_fraud = F_CUM_Finan_rep_fraud;
if M_CUM_Tax_relat_fraud = . then P_CUM_Tax_relat_fraud = F_CUM_Tax_relat_fraud;
if M_CUM_other_finan_crime = . then P_CUM_other_finan_crime = F_CUM_other_finan_crime;

if F_CUM_Muu3 = . then P_CUM_Muu3 = M_CUM_Muu3;
if F_CUM_Muu4 = . then P_CUM_Muu4 = M_CUM_Muu4;
if F_CUM_Muu5 = . then P_CUM_Muu5 = M_CUM_Muu5;
if F_CUM_Talous = . then P_CUM_Talous = M_CUM_Talous;
if F_CUM_Talous_kaikki = . then P_CUM_Talous_kaikki = M_CUM_Talous_kaikki;
if F_CUM_Kirjanpitorikos_kaikki = . then P_CUM_Kirjanpitorikos_kaikki = M_CUM_Kirjanpitorikos_kaikki;
if F_CUM_Liikenne = . then P_CUM_Liikenne = M_CUM_Liikenne;
if F_CUM_henkiterveys = . then P_CUM_henkiterveys = M_CUM_henkiterveys;
if F_CUM_Finan_rep_fraud = . then P_CUM_Finan_rep_fraud = M_CUM_Finan_rep_fraud;
if F_CUM_Tax_relat_fraud = . then P_CUM_Tax_relat_fraud = M_CUM_Tax_relat_fraud;
if F_CUM_other_finan_crime = . then P_CUM_other_finan_crime = M_CUM_other_finan_crime;

if M_D_Kirjanpitorikos_tuomio_2 = 1 or F_D_Kirjanpitorikos_tuomio_2 = 1 then P_D_Kirjanpitorikos_tuomio_2 = 1;
if M_D_muu_rikos_4_tuomio_2 = 1 or F_D_muu_rikos_4_tuomio_2 = 1 then P_D_muu_rikos_4_tuomio_2 = 1;
if M_D_muu_rikos_5_tuomio_2 = 1 or F_D_muu_rikos_5_tuomio_2 = 1 then P_D_muu_rikos_5_tuomio_2 = 1;
if M_D_talous_tuomio_2 = 1 or F_D_talous_tuomio_2 = 1 then P_D_talous_tuomio_2 = 1;
if M_D_talous_kaikki_tuomio_2 = 1 or F_D_talous_kaikki_tuomio_2 = 1 then P_D_talous_kaikki_tuomio_2 = 1;
if M_D_liikenne_tuomio_2 = 1 or F_D_liikenne_tuomio_2 = 1 then P_D_liikenne_tuomio_2 = 1;

if M_D_Kirjanpitorikos_kaikki_2 = 1 or F_D_Kirjanpitorikos_kaikki_2 = 1 then P_D_Kirjanpitorikos_kaikki_2 = 1;
if M_D_muu_rikos_4_2 = 1 or F_D_muu_rikos_4_2 = 1 then P_D_muu_rikos_4_2 = 1;
if M_D_muu_rikos_5_2 = 1 or F_D_muu_rikos_5_2 = 1 then P_D_muu_rikos_5_2 = 1;
if M_D_talous_2 = 1 or F_D_talous_2 = 1 then P_D_talous_2 = 1;
if M_D_talous_kaikki_2 = 1 or F_D_talous_kaikki_2 = 1 then P_D_talous_kaikki_2 = 1;

if M_D_Lifetime_KPrikos_tuomio = 1 or F_D_Lifetime_KPrikos_tuomio = 1 then P_D_Lifetime_KPrikos_tuomio = 1;
if M_D_Lifetime_muu_rikos_3_tuomio = 1 or F_D_Lifetime_muu_rikos_3_tuomio = 1 then P_D_Lifetime_muu_rikos_3_tuomio = 1;
if M_D_Lifetime_muu_rikos_4_tuomio = 1 or F_D_Lifetime_muu_rikos_4_tuomio = 1 then P_D_Lifetime_muu_rikos_4_tuomio = 1;
if M_D_Lifetime_talous_tuomio = 1 or F_D_Lifetime_talous_tuomio = 1 then P_D_Lifetime_talous_tuomio = 1;
if M_D_Lifetime_talous_kaik_tuomio = 1 or F_D_Lifetime_talous_kaik_tuomio = 1 then P_D_Lifetime_talous_kaik_tuomio = 1;
if M_D_Lifetime_henkiterv_tuomio = 1 or F_D_Lifetime_henkiterv_tuomio = 1 then P_D_Lifetime_henkiterv_tuomio = 1;
if M_D_Lifetime_liikenne_tuomio = 1 or F_D_Lifetime_liikenne_tuomio = 1 then P_D_Lifetime_liikenne_tuomio = 1;

if M_D_Lifetime_Kirjpitorikos = 1 or F_D_Lifetime_Kirjpitorikos = 1 then P_D_Lifetime_Kirjpitorikos = 1;
if M_D_Lifetime_muu_rikos_4 = 1 or F_D_Lifetime_muu_rikos_4 = 1 then P_D_Lifetime_muu_rikos_4 = 1;
if M_D_Lifetime_talous = 1 or F_D_Lifetime_talous = 1 then P_D_Lifetime_talous = 1;
if M_D_Lifetime_talous_kaikki = 1 or F_D_Lifetime_talous_kaikki = 1 then P_D_Lifetime_talous_kaikki = 1;
if M_D_Lifetime_henkiterv = 1 or F_D_Lifetime_henkiterv = 1 then P_D_Lifetime_henkiterv = 1;
if M_D_Lifetime_liikenne = 1 or F_D_Lifetime_liikenne = 1 then P_D_Lifetime_liikenne = 1;

if M_D_Kirjanpitorikos_tuomio = 1 or F_D_Kirjanpitorikos_tuomio = 1 then P_D_Kirjanpitorikos_tuomio = 1;
if M_D_muu_rikos_3_tuomio = 1 or F_D_muu_rikos_3_tuomio = 1 then P_D_muu_rikos_3_tuomio = 1;
if M_D_muu_rikos_4_tuomio = 1 or F_D_muu_rikos_4_tuomio = 1 then P_D_muu_rikos_4_tuomio = 1;
if M_D_muu_rikos_5_tuomio = 1 or F_D_muu_rikos_5_tuomio = 1 then P_D_muu_rikos_5_tuomio = 1;
if M_D_talous_tuomio = 1 or F_D_talous_tuomio = 1 then P_D_talous_tuomio = 1;
if M_D_talous_kaikki_tuomio = 1 or F_D_talous_kaikki_tuomio = 1 then P_D_talous_kaikki_tuomio = 1;
if M_D_henkiterv_tuomio = 1 or F_D_henkiterv_tuomio = 1 then P_D_henkiterv_tuomio = 1;
if M_D_liikenne_tuomio = 1 or F_D_liikenne_tuomio = 1 then P_D_liikenne_tuomio = 1;

if M_BUSINESS_SOCIALDEG = 0 or F_BUSINESS_SOCIALDEG = 0 then P_BUSINESS_SOCIALDEG = 0;
if M_BUSINESS_SOCIALDEG = 1 or F_BUSINESS_SOCIALDEG = 1 then P_BUSINESS_SOCIALDEG = 1;

P_SALARYTOTAL = ((M_SALARYTOTAL + F_SALARYTOTAL) / 2);
P_TOTALINCOME = ((M_TOTALINCOME + F_TOTALINCOME) / 2);
P_CAPITALTOTAL = ((M_CAPITALTOTAL + F_CAPITALTOTAL) / 2);

P_Lifetime_Sum_divorce = ((M_lifetime_Sum_divorce + F_lifetime_Sum_divorce) / 2);
P_CUM_Sum_divorce = ((M_CUM_Sum_divorce + F_CUM_Sum_divorce) / 2);

if M_D_MARITAL_STATUS = 0 or F_D_MARITAL_STATUS = 0 then P_D_MARITAL_STATUS = 0;

if M_D_MARITAL_STATUS = 1 or F_D_MARITAL_STATUS = 1 then P_D_MARITAL_STATUS = 1;

if M_SALARYTOTAL = . then P_SALARYTOTAL = F_SALARYTOTAL;
if F_SALARYTOTAL = . then P_SALARYTOTAL = M_SALARYTOTAL;
if M_TOTALINCOME = . then P_TOTALINCOME = F_TOTALINCOME;
if F_TOTALINCOME = . then P_TOTALINCOME = M_TOTALINCOME;
if M_CAPITALTOTAL = . then P_CAPITALTOTAL = F_CAPITALTOTAL;
if F_CAPITALTOTAL = . then P_CAPITALTOTAL = M_CAPITALTOTAL;

if F_lifetime_Sum_divorce = . then P_lifetime_Sum_divorce = M_lifetime_Sum_divorce;
if F_CUM_Sum_divorce = . then P_CUM_Sum_divorce = M_CUM_Sum_divorce;

if M_lifetime_Sum_divorce = . then P_lifetime_Sum_divorce = F_lifetime_Sum_divorce;
if M_CUM_Sum_divorce = . then P_CUM_Sum_divorce = F_CUM_Sum_divorce;

P_EDULEVEL = ((M_EDULEVEL + F_EDULEVEL) / 2);

if M_EDULEVEL = . then P_EDULEVEL = F_EDULEVEL;
if F_EDULEVEL = . then P_EDULEVEL = M_EDULEVEL;

P_D_Vanh_positio = 0;

if F_D_Vanh_positio = 1 or M_D_Vanh_positio = 1 then P_D_Vanh_positio = 1;

if id = '' then delete;

drop M_firm24 M_firm25 M_firm26 M_firm27 M_firm28 M_firm29 M_firm30
M_firm31 M_firm32 M_firm33 M_firm34 M_firm35 M_firm36 M_firm37 M_firm38 M_firm39 M_firm40
M_firm41 M_firm42 M_firm43 M_firm44 M_firm45 M_firm46 M_firm47 F_firm34 F_firm35 F_firm36
F_firm37 F_firm38 F_firm39 F_firm40 F_firm41 F_firm42 F_firm43 F_firm44 F_firm45 F_firm46
F_firm47 _name_;

run;

* Saves data;

data lib100.Kaikki_Vanhemmat_tvuosi_250925;
set kaikki_5;
run;




